uniform lowp samplerCube tex3;
uniform lowp sampler2D tex1;
uniform lowp sampler2D tex2;

varying mediump vec2 v_v2TexCoord;
varying lowp vec3 v_v3WorldPosition;

uniform lowp mat3 u_m33NormalTransform;

uniform lowp vec4 u_v4Color;
uniform lowp vec3 u_v3LightDir;

uniform lowp vec3 u_v3PaintColor;

void main() 
{	
	lowp vec4 v4TextureNormal = texture2D(tex1, v_v2TexCoord); // v4TextureNormal.w contains gloss
	lowp vec4 v4TextureDiffuse = texture2D(tex2, v_v2TexCoord); // v4TextureDiffuse.w contains ambient occlusion
	
	// todo: Is there a way to pre transform to avoid multiplying by u_m33NormalTransform during the fragment shader?
	// todo: I think it might require the cube map to be rotated, which wont work for different car body parts.
	// todo: It is an expensive per pixel operation so it would be nice to avoid it.
	lowp vec3 v3Normal = (2.0 * (v4TextureNormal.xyz - vec3(0.5, 0.5, 0.5))) * u_m33NormalTransform;
	lowp vec3 v3TextureCube = textureCube(tex3, reflect(v_v3WorldPosition, v3Normal)).xyz;
	
	gl_FragColor.xyz = 
		v3TextureCube * v3TextureCube * v4TextureNormal.w * v4TextureDiffuse.w * 0.5 + 
		(v4TextureDiffuse.rbb + v4TextureDiffuse.g * (u_v3PaintColor - v4TextureDiffuse.rbb)) * (dot(v3Normal, u_v3LightDir) + 1.5) * u_v4Color.xyz * v4TextureDiffuse.w;

	
				
}
