precision highp float;

layout(set = 0, binding = 0) uniform U
{    
	mat4 m44ModelViewProjection;
	mat3 m33SpecularRotation;
	vec3 v3LightDir;
} u;

#ifdef SPOT_LIGHT
layout(set = 1, binding = 0) uniform U2
{    
	vec3 v3ObjectPosition;
} u2;
#endif

in vec4 a_v4Position;
in vec2 a_v2TexCoordLightmap;
in vec3 a_v3Normal;

out highp vec4 v_v4ShadowMapPosition;
out highp vec2 v_v2TexCoordLightmap;
out lowp vec3 v_v3Normal;
out vec3 v_v3LightDir;

void main() 
{
	v_v3Normal = a_v3Normal * u.m33SpecularRotation;
	v_v2TexCoordLightmap = a_v2TexCoordLightmap;
#ifdef SPOT_LIGHT
	v_v4ShadowMapPosition = (u.m44ModelViewProjection * a_v4Position);
	v_v4ShadowMapPosition /= v_v4ShadowMapPosition.w;
//	v_v4ShadowMapPosition = ((v_v4ShadowMapPosition * 0.5) + 0.5);
	v_v4ShadowMapPosition.xyw *= 0.5;
	v_v4ShadowMapPosition.xyw += 0.5;
#else
//	v_v4ShadowMapPosition = ((u.m44ModelViewProjection * a_v4Position) * 0.5) + 0.5;
	v_v4ShadowMapPosition = (u.m44ModelViewProjection * a_v4Position);
	v_v4ShadowMapPosition.xyw *= 0.5;
	v_v4ShadowMapPosition.xyw += 0.5;
#endif

#ifdef SPOT_LIGHT
	v_v3LightDir = normalize(((a_v4Position.xyz * u.m33SpecularRotation) + u2.v3ObjectPosition) - u.v3LightDir);
#else
	v_v3LightDir = normalize(u.v3LightDir);
#endif

	gl_Position = vec4((v_v2TexCoordLightmap.x - 0.5) * 2.0, (v_v2TexCoordLightmap.y - 0.5) * 2.0, 0.0, 1.0);
}

