
layout(location = 0) out vec4 out_v4Color;

layout(set = 1, binding = 0) uniform U1
{
	mat4 m44ModelViewProjection;
	mat4 m44Model;
	//lowp mat3 m33NormalTransform;
} u1;

layout(set = 2, binding = 0) uniform U2
{
	vec4 v4Color;
	vec3 v3LightDir;
	highp vec3 v3EyePosition;
	vec3 v3PaintColour;
} u2;

layout(set = 0, binding = 1003) uniform lowp samplerCube tex3;
layout(set = 0, binding = 1001) uniform lowp sampler2D tex1;
layout(set = 0, binding = 1002) uniform lowp sampler2D tex2;

in mediump vec2 v_v2TexCoord;
in mediump vec3 v_v3WorldPosition;

void main() 
{	
	lowp vec4 v4TextureNormal = texture(tex1, v_v2TexCoord); // v4TextureNormal.w contains gloss
	lowp vec4 v4TextureDiffuse = texture(tex2, v_v2TexCoord); // v4TextureNormal.w contains ambient occlusion
	
	// todo: Is there a way to pre transform to avoid multiplying by u1.m33NormalTransform during the fragment shader?
	// todo: I think it might require the cube map to be rotated, which wont work for different car body parts.
	// todo: It is an expensive per pixel operation so it would be nice to avoid it.
	lowp vec3 v3Normal = (2.0 * (v4TextureNormal.xyz - vec3(0.5, 0.5, 0.5))) * mat3(u1.m44Model);
	lowp vec4 v4TextureCube = texture(tex3, reflect(v_v3WorldPosition - u2.v3EyePosition, v3Normal));
	
	out_v4Color.xyz = 
		v4TextureCube.xyz * v4TextureCube.xyz * v4TextureNormal.w * v4TextureDiffuse.w * 0.5 + 
		v4TextureDiffuse.xyz * (dot(v3Normal, u2.v3LightDir) + 1.5) * u2.v4Color.xyz * v4TextureDiffuse.w;
}
