#include "include.h"
//precision lowp float;

layout(location = 0) out vec4 out_v4Color;

layout(binding = 1001) uniform sampler2D tex;
#ifdef TEXTURE_OVERLAY
layout(binding = 1002) uniform sampler2D texOverlay;
#endif
in vec2 v_v2TexCoord;
in vec4 v_v4Color;
#ifdef TEXTURE_SDF
in float v_fThreshold;
#endif
void main() 
{
    vec4 v4Texture = texture(tex, v_v2TexCoord);
    out_v4Color.rgb = sRGB_to_UNORM(v4Texture.r) * v_v4Color.rgb;

#ifdef TEXTURE_SDF
    float sdf = v4Texture.g;
    float fw = fwidth(sdf);
    out_v4Color.a = smoothstep(v_fThreshold - fw * 0.5, v_fThreshold + fw * 0.5, sdf);
#else
    out_v4Color.a = v4Texture.g;
#endif

#ifdef TEXTURE_OVERLAY
    out_v4Color.a *= texture(texOverlay, v_v2TexCoord).g;
#endif

    out_v4Color.a *= v_v4Color.a;
}
