
//precision mediump float;

layout(location = 0) out vec4 out_v4Color;

layout(binding = 1001) uniform sampler2D tex;

in mediump vec2 v_v2TexCoord;
in lowp vec4 v_v4Color;
#ifdef TEXTURE_SDF
in float v_fThreshold;
#endif
in mediump float v_fAlphaVFadeLeft;
in mediump float v_fAlphaVFadeRight;
in mediump float v_fAlphaVFadeTop;
in mediump float v_fAlphaVFadeBottom;

void main() 
{
	float fAlphaA = min(v_fAlphaVFadeTop, v_fAlphaVFadeBottom);
	float fAlphaB = min(v_fAlphaVFadeLeft, v_fAlphaVFadeRight);

	float fAlpha = min( fAlphaA, fAlphaB);
	fAlpha = smoothstep(0.0, 0.01,fAlpha);
	vec4 v4Texture = texture(tex, v_v2TexCoord);
	out_v4Color.rgb = v4Texture.r * v_v4Color.rgb;	

    // --- alpha channel ---
#ifdef TEXTURE_SDF
    float sdf = v4Texture.g;
    float fw  = fwidth(sdf);
    float sdfAlpha = smoothstep(v_fThreshold - fw * 0.5,
                                v_fThreshold + fw * 0.5,
                                sdf);
    out_v4Color.a = sdfAlpha * v_v4Color.a * fAlpha;
#else
    out_v4Color.a = v4Texture.g * v_v4Color.a * fAlpha;
#endif

}
