
layout(location = 0) out vec4 out_v4Color;

layout(binding = 1001) uniform lowp sampler2D tex;

in mediump vec2 v_v2TexCoord;
in lowp vec4 v_v4Color;
#ifdef SMOOTH_CLIP
in mediump float v_fAlphaVFadeLeft;
in mediump float v_fAlphaVFadeRight;
in mediump float v_fAlphaVFadeTop;
in mediump float v_fAlphaVFadeBottom;
#endif

void main() 
{
    out_v4Color = (texture(tex, v_v2TexCoord) * v_v4Color);
#ifdef SMOOTH_CLIP
	float fAlphaA = min(v_fAlphaVFadeTop, v_fAlphaVFadeBottom);
	float fAlphaB = min(v_fAlphaVFadeLeft, v_fAlphaVFadeRight);

	float fAlpha = min( fAlphaA, fAlphaB);
	fAlpha = smoothstep(0.0, 0.01,fAlpha);
	out_v4Color.a *= fAlpha;
#endif
}
