
layout( push_constant ) uniform PushConstants
{
    mat4 m44ModelViewProjection;
	float fLeft;
	float fRight;
	float fTop;
	float fBottom;
} p;

in vec4 a_v4Position;
in vec2 a_v2TexCoord;
in vec4 a_v4Color;

out mediump vec2 v_v2TexCoord;
out lowp vec4 v_v4Color;
#ifdef SMOOTH_CLIP
out mediump float v_fAlphaVFadeLeft;
out mediump float v_fAlphaVFadeRight;
out mediump float v_fAlphaVFadeTop;
out mediump float v_fAlphaVFadeBottom;
#endif

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v4Color = a_v4Color * vec4(2.0, 2.0, 2.0, 1.0);
	gl_Position = p.m44ModelViewProjection * a_v4Position;
#ifdef SMOOTH_CLIP
	v_fAlphaVFadeLeft = (gl_Position.x - p.fLeft);
	v_fAlphaVFadeRight = (p.fRight - gl_Position.x);
	v_fAlphaVFadeTop = (p.fTop - gl_Position.y);
	v_fAlphaVFadeBottom = (gl_Position.y - p.fBottom);
#endif

}

