
precision lowp float;

layout(location = 0) out vec4 out_v4Color;

layout( push_constant ) uniform PushConstants
{
	float fRatio;
	float fReduceRadius;
} u;

layout(binding = 1001) uniform sampler2D tex;

in vec2 v_v2TexCoord;
in vec2 v_v2Pos;

void main() 
{
	vec4 v4Texture = texture(tex, v_v2TexCoord);
	out_v4Color = v4Texture;

	float fMult = (1.0 - length(v_v2Pos) - u.fReduceRadius) * 20.0;
	vec3 v3Mult = fMult * vec3(1.2, 1.1, 1.0);
	v3Mult = min(v3Mult, vec3(1.0));	
	out_v4Color.xyz *= v3Mult;
	
}
