

uniform mat4 u_m44ModelViewProjection;
uniform mat4 u_m44Model;

uniform mat3 u_m33ProjectionDeck;
uniform mat3 u_m33ProjectionGrip;

uniform vec2 u_v2WearOffset;
uniform vec2 u_v2WearScale;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;

varying vec2 v_v2TexCoord;
varying vec3 v_v3WorldPosition;
varying vec2 v_v2TexProjectionDeck;
varying vec2 v_v2TexProjectionGrip;
varying vec2 v_v2WearUV;

void main() 
{
	//v_v2TexProjection = vec2(a_v4Position.z * (1.0/8.12) + 0.5, a_v4Position.x * (1.0/2.0) + 0.5);
	
	v_v2TexProjectionDeck = (u_m33ProjectionDeck * vec3(a_v4Position.xz, 1)).xy;
	v_v2TexProjectionGrip = (u_m33ProjectionGrip * vec3(a_v4Position.xz, 1)).xy;
    v_v2TexProjectionGrip.y = -v_v2TexProjectionGrip.y; // todo: move this to the matrix
	
	
	v_v2TexCoord = a_v2TexCoord;
	gl_Position = u_m44ModelViewProjection * a_v4Position;
	
	v_v3WorldPosition = (u_m44Model * a_v4Position).xyz;
	v_v2WearUV = vec2(u_v2WearOffset.x + (a_v4Position.x * u_v2WearScale.x), u_v2WearOffset.y + (a_v4Position.z * u_v2WearScale.y));
}
