layout(location = 0) out vec4 out_v4Color;

layout(set = 0, binding = 1) uniform U2
{
	lowp float inverseTexSizeU;
	lowp float inverseTexSizeV;
} u2;

layout(set = 0, binding = 1001) uniform lowp sampler2D tex1;
layout(set = 0, binding = 1002) uniform lowp sampler2D tex2;
layout(set = 0, binding = 1003) uniform lowp sampler2D tex3;

in mediump vec2 v_v2TexCoord;
in mediump vec2 v_v2TexCoord2;

void main() 
{
	lowp vec3 diffuse = texture(tex3, v_v2TexCoord).rgb;
	lowp float mask = texture(tex2, v_v2TexCoord).r;	
	if(mask < 0.5)
	{
		mediump float gamma = 8.0;
		lowp vec3 brightness = pow(diffuse, vec3(gamma, gamma, gamma));
		lowp float lum = (brightness.r * 0.2126 + brightness.g * 0.7152 + brightness.b * 0.0722);

		if(lum < 0.05)
		{
			lowp float s01 = texture(tex1, v_v2TexCoord2 + vec2(-1.0, 0.0) * u2.inverseTexSizeU).x;
			lowp float s21 = texture(tex1, v_v2TexCoord2 + vec2(1.0, 0.0) * u2.inverseTexSizeU).x;
			lowp float s10 = texture(tex1, v_v2TexCoord2 + vec2(0.0, -1.0) * u2.inverseTexSizeV).x;
			lowp float s12 = texture(tex1, v_v2TexCoord2 + vec2(0.0, 1.0) * u2.inverseTexSizeV).x;

			lowp vec3 va = normalize(vec3(0.3, 0.0, s21 - s01));
			lowp vec3 vb = normalize(vec3(0.0, 0.3, s12 - s10));

			lowp vec3 BumpNormal = cross(va, vb);

			lowp float NdotL = max(0.0, dot(BumpNormal, vec3(0.0, 0.0 , 1.0)));
			diffuse *= NdotL;

			if(NdotL > 0.0)
			{
				lowp vec3 reflection = reflect(vec3(0.0, 0.0, 1.0), BumpNormal);
				lowp float specular = max(0.0, dot(reflection, vec3(0.0, 0.25, 0.75)));
				diffuse += pow(specular, 1.3);
			}
		}
	}
	out_v4Color.rgb = diffuse;
}