layout(location = 0) out vec4 out_v4Color;

layout(binding = 1001) uniform lowp sampler2D tex1;
layout(binding = 1002) uniform lowp sampler2D tex2;
layout(binding = 1003) uniform lowp sampler2D tex3;
layout(binding = 1004) uniform lowp sampler2D tex4;

in mediump vec2 v_v2TexCoord;
in mediump vec2 v_v2TexCoord2;

void main() 
{
	lowp float diffuse = texture(tex1, v_v2TexCoord2).r;
	lowp float mask = texture(tex2, v_v2TexCoord).r;
	diffuse *= 0.6;	

	lowp vec3 luminosity = texture(tex3, v_v2TexCoord).rgb;
	mediump float gamma = 8.0;
	lowp vec3 brightness = pow(luminosity, vec3(gamma, gamma, gamma));
	lowp float lum = (brightness.r * 0.2126 + brightness.g * 0.7152 + brightness.b * 0.0722);

	if(lum >= 0.05)
	{
		diffuse *= 0.5;
	}

	if(mask >= 0.5)
	{
		diffuse = 0.15;
	}
	lowp vec2 coords = gl_FragCoord.xy / 512.0;
	lowp vec4 WearSpecAo = texture(tex4, coords);
	WearSpecAo.r = diffuse;
	out_v4Color = WearSpecAo;
}
