layout(location = 0) out vec4 out_v4Color;

layout(set = 0, binding = 1) uniform U2
{
	lowp float inverseTexSizeU;
	lowp float inverseTexSizeV;
} u2;

layout(binding = 1001) uniform lowp sampler2D tex1;
layout(binding = 1002) uniform lowp sampler2D tex2;
layout(binding = 1003) uniform lowp sampler2D tex3;

in mediump vec2 v_v2TexCoord;
in mediump vec2 v_v2TexCoord2;
in lowp vec3 v_v3Normals;
in lowp vec3 v_v3Tangents;

void main() 
{
	lowp vec3 Normal = normalize(v_v3Normals);
	lowp float mask = texture(tex2, v_v2TexCoord).r;	
	if(mask < 0.5)
	{
		lowp vec3 diffuse = texture(tex3, v_v2TexCoord).rgb;
		mediump float gamma = 8.0;
		lowp vec3 brightness = pow(diffuse, vec3(gamma, gamma, gamma));
		lowp float lum = (brightness.r * 0.2126 + brightness.g * 0.7152 + brightness.b * 0.0722);

		lowp vec3 Tangent = normalize(v_v3Tangents);
		Tangent = normalize(Tangent - dot(Tangent, Normal) * Normal);
		lowp vec3 BiTangent = cross(Tangent, Normal);
		lowp mat3 TBN = mat3(Tangent, BiTangent, Normal);

		lowp float s01 = texture(tex1, v_v2TexCoord2 + vec2(-1.0, 0.0) * u2.inverseTexSizeU).x;
		lowp float s21 = texture(tex1, v_v2TexCoord2 + vec2(1.0, 0.0) * u2.inverseTexSizeU).x;
		lowp float s10 = texture(tex1, v_v2TexCoord2 + vec2(0.0, -1.0) * u2.inverseTexSizeV).x;
		lowp float s12 = texture(tex1, v_v2TexCoord2 + vec2(0.0, 1.0) * u2.inverseTexSizeV).x;

		lowp vec3 va;
		lowp vec3 vb;
		if(lum < 0.05)
		{
			va = normalize(vec3(0.4, 0.0, s21 - s01));
			vb = normalize(vec3(0.0, 0.4, s12 - s10));
		}
		else
		{
			va = normalize(vec3(0.9, 0.0, s21 - s01));
			vb = normalize(vec3(0.0, 0.9, s12 - s10));
		}
		lowp vec3 BumpNormal = cross(va, vb);

		Normal = TBN * BumpNormal;
		Normal = normalize(Normal);
	}
	out_v4Color.rgb = (Normal * 0.5 + 0.5).rbg;
}
