
layout(set = 1, binding = 1) uniform U
{    
	mat4 m44ModelViewProjection;
	mat4 m44Model;
	mat3 m33Projection;
	vec2 v2WearOffset;
	vec2 v2WearScale;
} u;

in vec4 a_v4Position;	
in vec2 a_v2TexCoord;

out vec2 v_v2TexCoord;
out vec3 v_v3WorldPosition;
out vec2 v_v2WearUV;

#if defined (CUSTOMIZABLE_GRIP) || defined (CUSTOMIZABLE_DECK)
out vec2 v_v2TexProjection;
#endif

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	gl_Position = u.m44ModelViewProjection * a_v4Position;	
	v_v3WorldPosition = (u.m44Model * a_v4Position).xyz;
	v_v2WearUV = vec2(u.v2WearOffset.x + (a_v4Position.x * u.v2WearScale.x), u.v2WearOffset.y + (a_v4Position.z * u.v2WearScale.y));
#ifdef CUSTOMIZABLE_DECK
	v_v2TexProjection = (u.m33Projection * vec3(a_v4Position.xz, 1)).xy;
//    v_v2TexProjection.y = -v_v2TexProjection.y; // todo: optimize by moving to the matrix and outside the shader, and merge ifdefs
#endif
#ifdef CUSTOMIZABLE_GRIP
	v_v2TexProjection = (u.m33Projection * vec3(a_v4Position.xz, 1)).xy;
    v_v2TexProjection.y = -v_v2TexProjection.y; // todo: optimize by moving to the matrix and outside the shader, and merge ifdefs
#endif
}
