
layout(binding = 1001) uniform sampler2D tex;

layout( push_constant ) uniform PushConstants
{    
	layout(offset=64) vec4 v4Color;
} u;

layout(location = 0) in vec2 v_v2TexCoord;
layout(location = 1) in vec2 v_v2WearAndRandSeed;

layout(location = 0) out vec4 out_v4Color;

float rand(vec2 co)
{
    float a = 12.9898;
    float b = 78.233;
    float c = 43758.5453;
    float dt= dot(co.xy ,vec2(a,b));
    float sn= mod(dt,3.14);
    
    return fract(sin(sn) * c);
}

void main() 
{
	float fTotalWear = texture(tex, v_v2TexCoord).r * v_v2WearAndRandSeed.x;
    float fRand = rand(vec2(-gl_FragCoord.x * cos(v_v2WearAndRandSeed.y), -gl_FragCoord.y * sin(v_v2WearAndRandSeed.y)));
    float fWear = v_v2WearAndRandSeed.x - (fTotalWear + (fTotalWear * 0.25));
    fRand = step(fRand, fWear);
    out_v4Color.rgb = u.v4Color.rgb * fRand;
}