precision lowp float;

uniform lowp sampler2D tex;
#ifndef DETAIL_LOW
	uniform lowp samplerCube texCubeMap;
#endif
#ifndef DETAIL_LOW
	uniform lowp sampler2D texSpecular;
#endif
#ifdef SIGNAGE
	uniform lowp sampler2D texSignage;
	varying mediump vec2 v_v2TexCoordSignage;
	varying lowp vec4 v_v4SignageModifier;
#endif

varying mediump vec2 v_v2TexCoord;
#ifdef DETAIL_HIGH
	varying lowp vec3 v_v3Normal;
	varying mediump vec3 v_v3WorldPosition;
#else
	varying mediump vec3 v_v3Reflection;
#endif

#ifdef REWIND
uniform lowp float u_fRewindEffect;
#endif
uniform lowp float u_fBrightness;
uniform mediump vec3 u_v3EyePosition;

void main() 
{
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord);
	#ifndef DETAIL_LOW
		lowp float fSpecular = texture2D(texSpecular, v_v2TexCoord).r;	
	#endif
	#ifdef SIGNAGE
		lowp vec4 v4TextureSignage = texture2D(texSignage, v_v2TexCoordSignage);
		lowp vec3 v3SignageMod = vec3(0.65, 0.25, 0.0);
		v4Texture = ((v4TextureSignage - v_v4SignageModifier.y) * v_v4SignageModifier.x) + v4Texture;
	#endif

	#ifdef DETAIL_HIGH
		mediump vec3 v3Incident = v_v3WorldPosition - u_v3EyePosition;
		mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v_v3Normal) * v_v3Normal / dot(v_v3Normal, v_v3Normal);	
		lowp vec4 v4TextureCube = textureCube(texCubeMap, v3Reflection);
		
		#ifdef REWIND
			lowp vec4 v4Tmp1 = (v4Texture + v4TextureCube * fSpecular) * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;	
		#else
			lowp vec4 v4Tmp1 = (v4Texture + v4TextureCube * fSpecular);
		#endif		

		lowp vec4 v4Tmp2 = 1.0 - v4Tmp1;
		gl_FragColor = v4Tmp1 * (2.0 - u_fBrightness) + (1.0 - v4Tmp2 * v4Tmp2 * v4Tmp2) * (u_fBrightness - 1.0);	
	#elif defined (DETAIL_MEDIUM)
		lowp vec4 v4TextureCube = textureCube(texCubeMap, v_v3Reflection);
		#ifdef REWIND
			gl_FragColor = (v4Texture + v4TextureCube * fSpecular) * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;	
		#else
			gl_FragColor = v4Texture + v4TextureCube * fSpecular;
		#endif	
	#else
		#ifdef REWIND
			gl_FragColor = v4Texture * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;
		#else
			gl_FragColor = v4Texture;
		#endif
	#endif	

	//#ifdef SIGNAGE
	//		gl_FragColor = v_v4SignageModifier;
	//#endif
	
}

