uniform mat4 u_m44ModelViewProjection;
#ifndef DETAIL_LOW
uniform mat3 u_m33SpecularRotation;
#endif

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec3 a_v3Normal;
#ifdef SIGNAGE
attribute vec2 a_v2TexCoord2;
attribute vec4 a_v4Color;
#endif

varying mediump vec2 v_v2TexCoord;
#ifdef SIGNAGE
varying mediump vec2 v_v2TexCoordSignage;
varying lowp vec4 v_v4SignageModifier;
#endif

#ifdef DETAIL_HIGH
varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;
#elif defined (DETAIL_MEDIUM)
varying mediump vec3 v_v3Reflection;
uniform mediump vec3 u_v3EyePosition;
#endif

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
#ifdef SIGNAGE
	v_v2TexCoordSignage = a_v2TexCoord2;
	v_v4SignageModifier = a_v4Color * (1.0 / 255.0);
#endif

	gl_Position = u_m44ModelViewProjection * a_v4Position;
#ifdef DETAIL_HIGH
	v_v3Normal = a_v3Normal * u_m33SpecularRotation;
	v_v3WorldPosition = a_v4Position.xyz * u_m33SpecularRotation;
#elif defined (DETAIL_MEDIUM)	
	vec3 v3Normal = a_v3Normal * u_m33SpecularRotation;			
	mediump vec3 v3Incident = a_v4Position.xyz * u_m33SpecularRotation - u_v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v3Normal) * v3Normal / dot(v3Normal, v3Normal);		
	v_v3Reflection = v3Reflection;
#endif
}