


layout(binding = 0) uniform U
{    
	mat4 m44ModelViewProjection;
	mat3 m33SpecularRotation;
	mediump vec3 v3EyePosition;
	lowp float fBrightness;
	lowp float fRewindEffect;
	float fGamma;
	float fZOffset;
	float fZClamp;
	float fMinZOffset;  
} u;


in vec4 a_v4Position;
in vec2 a_v2TexCoord;
in vec3 a_v3Normal;
#ifdef SIGNAGE
	in vec2 a_v2TexCoord2;
	in vec4 a_v4Color;
#endif

#ifdef SIGNAGE
	layout(location = 4) out mediump vec2 v_v2TexCoordSignage;
	layout(location = 5) out lowp vec4 v_v4SignageModifier;
#endif

out mediump vec2 v_v2TexCoord;
#ifdef DETAIL_HIGH
	layout(location = 1) out lowp vec3 v_v3Normal;
	layout(location = 2) out mediump vec3 v_v3WorldPosition;
#elif defined (DETAIL_MEDIUM)
	layout(location = 3) out mediump vec3 v_v3Reflection;
#endif

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
#ifdef SIGNAGE
	v_v2TexCoordSignage = a_v2TexCoord2;
	v_v4SignageModifier = a_v4Color;
#endif

	gl_Position = u.m44ModelViewProjection * a_v4Position;
#ifdef DETAIL_HIGH
	v_v3Normal = a_v3Normal * u.m33SpecularRotation;
	v_v3WorldPosition = a_v4Position.xyz * u.m33SpecularRotation;
#elif defined (DETAIL_MEDIUM)	
	vec3 v3Normal = a_v3Normal * u.m33SpecularRotation;			
	mediump vec3 v3Incident = a_v4Position.xyz * u.m33SpecularRotation - u.v3EyePosition;
	mediump vec3 v3Reflection = v3Incident - 2.0 * dot(v3Incident, v3Normal) * v3Normal / dot(v3Normal, v3Normal);		
	v_v3Reflection = v3Reflection;
#endif
}