
precision lowp float;

uniform lowp sampler2D tex;
uniform lowp samplerCube texCubeMap;
uniform lowp sampler2D texSpecular;

varying mediump vec2 v_v2TexCoord;
varying lowp vec3 v_v3Normal;
varying mediump vec3 v_v3WorldPosition;

uniform mediump vec3 u_v3EyePosition;
uniform lowp float u_fRewindEffect;
uniform lowp float u_fBrightness;

void main() 
{
	lowp vec4 v4Texture = texture2D(tex, v_v2TexCoord);
	
	gl_FragColor = v4Texture * (1.0 - u_fRewindEffect) + v4Texture.b * u_fRewindEffect;	
	
	vec3 v3Normal = normalize(v_v3Normal);
	float fBrightness = dot(v3Normal, normalize(vec3(1.2, 2.5, 0.5))) * 0.5 + 0.5;
	gl_FragColor *= fBrightness;
}
