
uniform mat4 u_m44ModelViewProjection;

uniform mat3 u_m33SpecularRotation;

attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;
attribute vec2 a_v2TexCoord3;
attribute vec3 a_v3Normal;
attribute vec4 a_v4Color;
attribute vec4 a_v4Color2;

varying mediump vec2 v_v2TexCoord;
varying mediump vec2 v_v2LightTexCoord;
varying mediump vec4 v_v4Color;
varying mediump vec4 v_v4Color2;

varying lowp vec3 v_v3Normal;
varying lowp vec3 v_v3WorldPosition;



void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v2LightTexCoord = a_v2TexCoord3;
	
	v_v4Color = a_v4Color * (1.0 / 255.0);
	v_v4Color2 = a_v4Color2 * (1.0 / 255.0);

	gl_Position = u_m44ModelViewProjection * a_v4Position;

	v_v3Normal = a_v3Normal * u_m33SpecularRotation;
	v_v3WorldPosition = a_v4Position.xyz * u_m33SpecularRotation;
}

