precision highp float;

layout(location = 0) out vec4 out_v4Color;

layout(set = 1, binding= 1001) uniform sampler2D tex_d;
layout(set = 1, binding= 1002) uniform sampler2D tex_n;
layout(set = 1, binding= 1003) uniform sampler2D tex_g_ao_a;
layout(set = 1, binding= 1004) uniform samplerCube tex_c;


layout(set = 0, binding = 1) uniform U
{			
	vec4 v4Color;
	vec3 v3LightDir;
	float fBrightness;
	vec3 v3LightDiffuse;
	float fFadeScale;
	float fFadeAmmountX;
} u;
			
layout(set = 1, binding = 2) uniform Material
{
	vec3 v3Diffuse0;
	vec3 v3Diffuse1;
	vec3 v3Ambient0;
	vec3 v3Ambient1;
	vec3 v3BaseSkinColour;
	vec3 v3SkinColour;
} material;

in vec2 v_v2TexCoord;
in highp vec3 v_v3MatrixX;
in highp vec3 v_v3MatrixY;
in highp vec3 v_v3MatrixZ;
in vec3 v_v3ViewDir;
in vec3 v_v3PositionForFade;
in float fFadeHeight;

vec3 ToGamma(vec3 v3In)
{
	return v3In;
	//return pow(v3In, vec3(1.0/1.0));
}
vec3 FromGamma(vec3 v3In)
{
	return v3In;
	//return pow(v3In, vec3(1.0));
}

void main() 
{

	if (u.fFadeAmmountX > 0.0)
	{
		float fInvFadeLength = u.fFadeScale / length(v_v3PositionForFade.xyz);
		out_v4Color.a = -v_v3PositionForFade.y * fInvFadeLength * 0.4 + 1.1;
		out_v4Color.a = min(out_v4Color.a, 1.1 - v_v3PositionForFade.x * fInvFadeLength * 0.175 * u.fFadeAmmountX);
		out_v4Color.a = min(out_v4Color.a, (-fFadeHeight + 70.0) * 0.1);
		//out_v4Color.a = min(out_v4Color.a, (gl_FragCoord.z - 0.40) * 3.0);
	}
	else 
	{
		out_v4Color.a = 1.0;
	}

	vec3 v3TextureD = texture(tex_d, v_v2TexCoord).rgb;
	vec3 v3TextureG_AO_A = texture(tex_g_ao_a, v_v2TexCoord).rgb;
	vec3 v3TextureN = vec3(texture(tex_n, v_v2TexCoord.st)).rgb;

	v3TextureD *= material.v3BaseSkinColour;
	v3TextureD *= material.v3SkinColour;

	highp vec3 v3Normal;
	{
		highp vec3 v3NormalTmp = v3TextureN;     
		v3NormalTmp = v3TextureN;
		v3NormalTmp -= 0.5;
		v3NormalTmp *= 2.0;
		v3Normal.x = dot(v3NormalTmp, v_v3MatrixX);
		v3Normal.y = dot(v3NormalTmp, v_v3MatrixY);
		v3Normal.z = dot(v3NormalTmp, v_v3MatrixZ);
	}
	//out_v4Color.rgb = v3Normal * 0.5 + 0.5;
	//out_v4Color.rgb = vec3(dot(u.v3LightDir, v3Normal) * 0.5 + 0.5);

	
	vec3 v3CubeLookup = reflect(normalize(v_v3ViewDir), v3Normal);	
	/*{ // fudge it
		v3CubeLookup = mix(v3Normal, v3CubeLookup, v3TextureG_AO_A.r);
		normalize(v3Normal);
	}*/
	vec3 v3texture = texture(tex_c, v3CubeLookup).rgb;	
	//out_v4Color.rgb = v3texture;
	
	vec3 v3textureD = texture(tex_c, v3Normal).rgb;	

	float fSpec = 0.05;

	fSpec += pow((1.0 - abs(dot(normalize(v_v3ViewDir), v3Normal))), 5.0) * 0.5;
		
	//out_v4Color.xyz = 
	//	v3texture * (v3TextureG_AO_A.r * v3TextureG_AO_A.b) * fSpec + 
	//	v3TextureD.xyz * ((dot(v3Normal, u.v3LightDir) * vec3(0.8)) * v3TextureG_AO_A.b + v3textureD * 0.3 + vec3(1.0)) * u.v4Color.xyz;

	
	//out_v4Color.xyz = 
	//	v3texture * (v3TextureG_AO_A.r * v3TextureG_AO_A.g) * fSpec + 
	//	v3TextureD.xyz * (((dot(v3Normal, u.v3LightDir) * vec3(0.3, 0.6, 0.9)) + v3textureD * vec3(0.1, 0.2, 0.3) + vec3(0.6, 0.6, 0.6)) * v3TextureG_AO_A.g + vec3(.6, 0.3, 0.0)) * u.v4Color.xyz;
	
	out_v4Color.xyz = 
		v3texture * (v3TextureG_AO_A.r * v3TextureG_AO_A.g) * fSpec + 
		v3TextureD.xyz * (((dot(v3Normal, u.v3LightDir) * material.v3Diffuse0) + v3textureD * material.v3Diffuse1 + material.v3Ambient0) * v3TextureG_AO_A.g + material.v3Ambient1) * u.v4Color.xyz;


	
	//out_v4Color.rgb = v3TextureWearSpecAo.rgb;
	vec3 v3Tmp = 1.0 - out_v4Color.rgb;

	out_v4Color.rgb = out_v4Color.rgb * (2.0 - u.fBrightness) + (1.0 - v3Tmp * v3Tmp * v3Tmp) * (u.fBrightness - 1.0);
	out_v4Color.a = min(out_v4Color.a, v3TextureG_AO_A.b);





}
