
layout(set = 0, binding = 0) uniform U
{
	mat4 m44ModelViewProjection;
	mat3 m33ModelRotation;
	mat3 m33Fade;
	vec4 v4Clip;
	vec3 v3EyePos;
} u;


in vec4 a_v4Position;
in vec2 a_v2TexCoord;

in highp vec3 a_v3MatrixX;
in highp vec3 a_v3MatrixY;
in highp vec3 a_v3MatrixZ;

out vec2 v_v2TexCoord;
out highp vec3 v_v3MatrixX;
out highp vec3 v_v3MatrixY;
out highp vec3 v_v3MatrixZ;
out vec3 v_v3ViewDir;
out vec3 v_v3PositionForFade;
out float fFadeHeight;


void main() 
{
	vec4 v4Position = a_v4Position;
	v4Position.w = 1.0;

	v_v2TexCoord = a_v2TexCoord;
		
    vec3 v3ViewDir = v4Position.xyz - u.v3EyePos;

	
	highp vec3 v3MatrixX = u.m33ModelRotation*a_v3MatrixX;
    highp vec3 v3MatrixY = u.m33ModelRotation*a_v3MatrixY;
  	highp vec3 v3MatrixZ = u.m33ModelRotation*a_v3MatrixZ;
	v_v3MatrixX = vec3(v3MatrixX.x, v3MatrixY.x, v3MatrixZ.x);
	v_v3MatrixY = vec3(v3MatrixX.y, v3MatrixY.y, v3MatrixZ.y);
	v_v3MatrixZ = vec3(v3MatrixX.z, v3MatrixY.z, v3MatrixZ.z);

	v_v3ViewDir = u.m33ModelRotation * v3ViewDir;



	
	if (u.v4Clip.w > 0.5)
	{
		v4Position.xyz -= u.v3EyePos;
		float fDot = dot(v4Position.xyz, u.v4Clip.xyz);
		vec3 v3SideDistance = v4Position.xyz - u.v4Clip.xyz * dot(v4Position.xyz, u.v4Clip.xyz);
		fDot -= (dot(v3SideDistance, v3SideDistance) * 0.09 - 25.0) * u.v4Clip.w - 12.0;
		v4Position.xyz -= u.v4Clip.xyz * fDot;
		if (fDot > 0.0)
			fDot *= 0.01;
		if (fDot > 15.0)
			fDot = 15.0;
		v4Position.xyz += u.v4Clip.xyz * fDot;
		v4Position.xyz += u.v3EyePos;
	}	
	    
	gl_Position = u.m44ModelViewProjection * v4Position;	
		
	if (u.v4Clip.w < -0.5)
	{
		gl_Position.z -= 0.05;
		if (gl_Position.z < 0.0)
		{
			gl_Position.z *= 0.01;
		}
		gl_Position.z += 0.05;


		if (gl_Position.z < 0.0)
			gl_Position.z = 0.0;
		if (gl_Position.w < 1.1)
			gl_Position.w = 1.1;
	}

	fFadeHeight = v4Position.y;
	v_v3PositionForFade = u.m33Fade * (v4Position.xyz - u.v3EyePos);

	
}
