

layout(binding = 0) uniform U
{    
	float fZOffset;
	float fZClamp;
	float fMinZOffset; 
} u;

layout( push_constant ) uniform PushConstants
{
    layout(offset=0) mat4 m44ModelViewProjection;
} p;

in vec4 a_v4Position;
in vec2 a_v2TexCoord;
in vec4 a_v4Color;

out vec2 v_v2TexCoord;
out vec4 v_v4Color;

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	v_v4Color = a_v4Color;// * (1.0 / 255.0);
	gl_Position = p.m44ModelViewProjection * a_v4Position;
	float fDiv = gl_Position.w;
	if (fDiv < u.fZClamp)
		fDiv = u.fZClamp;
	float zOffset = u.fZOffset / fDiv;
	if (zOffset < u.fMinZOffset)
		zOffset = u.fMinZOffset;
	gl_Position.z -= zOffset;
}

