

layout( push_constant ) uniform PushConstants
{
    layout(offset=0) mat4 m44ModelViewProj;
} p;

layout(binding = 0) uniform U
{    
	float fZOffset;
	float fZClamp;
	float fMinZOffset; 
} u;

in vec4 a_v4Position;
in vec2 a_v2TexCoord;

out vec2 v_v2TexCoord;

void main() 
{
	v_v2TexCoord = a_v2TexCoord;
	gl_Position = p.m44ModelViewProj * a_v4Position;
	float fDiv = gl_Position.w;
	if (fDiv < u.fZClamp)
		fDiv = u.fZClamp;
	float zOffset = u.fZOffset / fDiv;
	if (zOffset < u.fMinZOffset)
		zOffset = u.fMinZOffset;
	gl_Position.z -= zOffset;
}

